
 
 
 #include <DHT11.h>                               //Librerira del sensor DHT11
 int DHT = 2;                                     //Variable definida
 int rele1 = 8;                                   //Rele 1 es Calentador
 int rele2 = 9;                                   //Rele 2 es Ventilacion
 int rele3 = 10;                                  //Rele 3 es Bomba de riego
 int rele4 = 11;
 DHT11 dht11(DHT);                                //Definicion Liberia propia DHT
 int PTemperatura;                                //Selector de temperatura
 int Phumedad;                                    //Selector de porcentaje de humedad
 //-----------------Valores de las lecturas reales de los elementos ------------------------
 int Shumtierra;                                   //Valor del sensor de humedad en tierra
 int Stemp;                                        //Valor del sensor de Temperatura
 int Shum;                                         //Valor del sensor de humedad
 int Sluz;                                         //Valor de iluminacion






 void setup()
 {
      pinMode (rele2,OUTPUT);                    //definicion de pin como Salida / Entrada
      pinMode (rele1,OUTPUT);
      pinMode (rele3,OUTPUT);
      pinMode (rele4,OUTPUT);
      Serial.begin(9600); 
      pinMode (A1, INPUT);                        //Lectur Potenciometro de Temperatura
      pinMode (A2, INPUT);                        //Lectura potenciometro de Humedad
      pinMode (A3, INPUT);                        //Lectura Sensor de Humedad en tierra
      pinMode (A4, INPUT);
 }                                                //Lectura de Luxes
 
            
 void loop ()
 { 

      // ------------------------- Todo esto es para las pruebas de funcionamiento solamente----------------------------
      
      

      
      int SensorValue1 = analogRead(A1);                    //Tomamos muestra de A1, potenciometro que nos marcara la temperatura a alcanzar
      int SensorValue2 = analogRead(A2);                    //Tomamos muestra de A2, potenciometro que nos marcara la humedad a alcanzar
      PTemperatura = map(SensorValue1, 0, 1023, 10, 60);    // Escalamos el potencimetro en un rango entre 10 y 60 grados centigrados  
      Phumedad = map(SensorValue2, 0, 1023, 0, 100);        //Escalamos el potenciometro en un rango de 0 - 100%Humedad
      
      //--------------------------------------------YL-38 y Yl-69-----------------------------------------------------
      int SensorValue4 = analogRead(A3);                    //El YL38 estara conectado a la entrada analogica A0
      Shumtierra = map(SensorValue4, 0,1024,0,100);         // Escalamos la entrada analogica dada por el Yl38 determinando un rango entre 0 y 100%
      
      //----------------------------------------Fotoresistencias-------------------------------------------------------
      int SensorValue5 =analogRead(A4);
      Sluz=map(SensorValue5, 0,1023, 1,120);
      Sluz=Sluz*100;                                        //Escalamos la entrada entre un valor de 0 y 120000 donde 0 es oscuridad absoluta y 120000 luz absoluta.
      

      //----------------------------------------------- DHT11---------------------------------------------------------
      
      int err;                                    //se crea una variable err para avisarnos si se han producido errores con el sensor
      float Stemp, Shum;
       if((err = dht11.read(Shum, Stemp)) == 0)    // Si devuelve 0 es que ha leido bien
          {
             //Serial.print("Temperatura REAL: ");
             //Serial.print(Stemp);                  // temp guarda el valor de la temperatura real.
             //Serial.print(" Humedad REAL: ");
             //Serial.print(Shum);
             //Serial.println();
          }
       else                                     //Si devuelve cualquier cosa que no sea 0 lo tomara comoe error y nos avisará.
          {
            Serial.println();
            Serial.print("EL SENSOR DE TEMPERATURA NO ESTA FUNCIONANDO CORRECTAMENTE");
            Serial.print(err);
            Serial.println();
             
          }

        

       //--------------------------------------------Control de la temperatura-----------------------------------------------------
       
       // La temperatura es una magnitud que varia lentamente por tanto el codigo no necesita ser demasiado rapido, el cambio de valores se actualizara siempre
       // al siguiente ciclo del micro
       //---------------------------------------------------------Envio a VB  ------------------------------------------------------------------------------------------------------
            
            Serial.print("--------------------------------------------------------");
            Serial.println();
            Serial.print("CONTROL DE TEMPERATURA");
            Serial.println();
            Serial.println();
            Serial.print("La temperatura Actual es : ");
            Serial.print(Stemp);Serial.print("Grados Centigrados");            
            Serial.println();
            Serial.print("La temperatura Limite es: ");
            Serial.print(PTemperatura);Serial.print(" Grados Centigrados");
            Serial.println();
            
            

       int toltemp=2;                                 //Introducimos la tolerancia que deseamos para el sistema de temperatura por defecto será 2ºC
       int Tdesmas;                                   //definimos la temperatura deseada + tolerancia y - tolerancia
       int Tdesmenos;
       Tdesmas = PTemperatura + toltemp;                                            //Operaciones para otorgar el valor despues de la tolerancia
       Tdesmenos = PTemperatura - toltemp;

        if (Stemp <= Tdesmenos || Stemp >= Tdesmas)                                  //Si la temperatua  es menor o igual que deseada o mayor o igual a la deseada entramos al bucle
         {
             
             
              if (Stemp <= Tdesmenos)                                               //La temperatura actual es menor que la deseada
              {
                digitalWrite(rele1,HIGH);                                           //Encendeos la salida de Rele1 y desconectamos el rele2 ya que son contrarias.
                digitalWrite(rele2,LOW);
                Serial.println();
                Serial.print("La temperatura es inferior a la deseada");
                Serial.println();
                Serial.print("Se ha activado el Calentador");                       //Aviso de la accion por terminal
                Serial.println();
                
                
               }
              else if (Stemp >= Tdesmas)                                            //La temperatura actual es mayor que la deseada
              {
                digitalWrite(rele2,HIGH);                               
                digitalWrite(rele1,LOW);
                Serial.print("La temperatura es superior a la deseada");
                Serial.println();
                Serial.print("Se ha activado el Extractor ");                         //Aviso de la accion por terminal
                Serial.println();
               
              }
         }
         else if (Stemp >= Tdesmenos || Stemp <= Tdesmas)                             //Condicion rebundante para asegurr el if. Si la temperatura esta entre el rango de la tolerancia
          {
            
             Serial.print("Temperatura dentro de los limites establecidos");                     //Aviso de situacion y desconexion de los rele
             Serial.println();
             digitalWrite(rele1,LOW);
             digitalWrite(rele2,LOW);
             Serial.println();
             
          }

          
          delay(1000);
          
//-------------------------------------------------------------- Control de humedad en tierra -------------------------------------------------------------------------------      

       int TolHum=20;                                  //Introducimos la tolerancia que deseamos para el sistema de humedad en % (¿¿¿¿¿Introducida desde el exterior????)
       int Hdesmas;                                   //definimos la Humedad deseada + tolerancia y - tolerancia
       
       Hdesmas = Phumedad + TolHum;                       //Operaciones para otorgar el valor despues de la tolerancia
       
            Serial.println();
            Serial.print("--------------------------------------------------------");
            Serial.println();
            Serial.print("CONTROL DE RIEGO");
            Serial.println();
            Serial.println();
            Serial.print("La Humedad del suelo Actual es : ");
            Serial.print(Shumtierra);Serial.print("%");            
            Serial.println();
            Serial.print("La Humedad deseada es: ");
            Serial.print(Phumedad);Serial.print("%");
            Serial.println();


        
            if (Shumtierra <= Phumedad && Sluz <= 3200)                                                                       //Si la Humedad  es menor entramos al bucle
               {
                Serial.println();
                digitalWrite(rele3,HIGH);                                                                                     //Encendeos la salida de Rele1 y desconectamos el rele2 ya que son contrarias.
                Serial.print("La humedad es menor que la deseada"); 
                Serial.println();
                Serial.print("El riego esta Activo");                                                                         //Aviso de la accion por terminal
                Serial.println();  
               }            
            else
                     if(Shumtierra >= Hdesmas)                                                                                //La humedad actual es mayor o igual que Hdesmas
                        {
                            Serial.print("La humedad es muy elevada"); 
                            Serial.println();
                            digitalWrite(rele3,LOW);
                        }
                    else{
                            Serial.print("Las condiciones ambientales no son optimas para el riego");                          //Aviso de situacion y desconexion de los rele
                            Serial.println();
                            digitalWrite(rele3,LOW);
                            Serial.println();
                        }
              
//-------------------------------------------------------Control humedad ambiental -----------------------------------------------------------------------------

   
          Serial.print("--------------------------------------------------------");
          Serial.println();
          Serial.print("La humedad relativa en el aire es: ");
          Serial.print(Shum);Serial.print("%");            
          Serial.println();

          if (Shum >= 80)
          {
                  Serial.print("La humedad en el aire es muy elevada. Conectada ventilacion forzada ");
                  digitalWrite(rele4,HIGH);
                  Serial.println();
          }
          else
          {
                  digitalWrite(rele4,LOW);
                  Serial.println();
          }


delay(2000);
}

        

  
  


